#!/bin/bash

function banner {

echo "--------------------------------------------------------------------------------"
echo 			installing tv plugin suite to $1
echo "--------------------------------------------------------------------------------"

}

function usage {
	echo 
	echo usage
	echo "      ./install.sh <path to installation location>"
	echo 
	exit 1
}

function testprefix {
	if [ -z $1 ] 
	then
		usage
	fi
	mkdir -p $1 >/dev/null 2>&1
	if [ $? != 0 ]
	then
		echo have no permission to write to the destination directory $1
		exit $?
	fi
}

function installplugin {
	cd $1
	PKG_CONFIG_PATH=$PKG_CONFIG_PATH:$2/lib/pkgconfig make 
	if [ $? != 0 ]
	then
		echo configure for $1 failed... exiting 
		exit $?
	fi
	echo make is done... invoke make install
	PKG_CONFIG_PATH=$PKG_CONFIG_PATH:$2/lib/pkgconfig make install

	echo installation done for $1
	cd ..
}
function updateplugin {
	cd $1
	PKG_CONFIG_PATH=$PKG_CONFIG_PATH:$2/lib/pkgconfig make 
	if [ $? != 0 ]
	then
		echo configure for $1 failed... exiting 
		exit $?
	fi
	echo make is done... invoke make update
	PKG_CONFIG_PATH=$PKG_CONFIG_PATH:$2/lib/pkgconfig make update


	echo update done for $1
	cd ..
}

# test if the destination is valid
testprefix $1

#print banner
banner $1

#install mms packages
installplugin mmstvplugin $1
installplugin mmstvchannelimportplugin $1
installplugin mmsepgimportplugin $1
installplugin mmsmusicplugin $1
installplugin mmsmixerplugin $1
