/***************************************************************************
 *   Copyright (C) 2005-2006 by                                            *
 *                                                                         *
 *      Stefan Schwarzer <sxs@morphine.tv>                                 *
 *      Guido Madaus     <bere@morphine.tv>                                *
 *      Jens Schneider   <pupeider@morphine.tv>                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef MMSEPGIMPORTPLUGIN_H_
#define MMSEPGIMPORTPLUGIN_H_

#include "mmsbase.h"
#include "mmsdata.h"
#include "mmsconfig.h"


class MMSEPGImportPlugin : public IMMSImportPlugin {
    private:
        MMSLogger               logger;
        MMSPluginData           plugindata;
        MMSImportSourceService  *iss;
        MMSTVChannelService     *tcs;
        MMSEPGService           *eps;
        bool                    dump;
        MMSFile                 *dumpfile;

        int                     time_offset;

    public:
        /* constructor/destructor */
        MMSEPGImportPlugin();        
        virtual ~MMSEPGImportPlugin();

        /* interface methods */
        bool initialize(MMSPluginData plugindata);
        bool execute();
        bool shutdown();
        bool cleanUp();

    private:
        void parseShortEventDesc(char *evtdesc, MMSEPGData *data);
        void parseLongEventDesc(char *evtdesc, MMSEPGData *data);
        void parseDescription(char *desc, int len, MMSEPGData *data);
        void throughBuffer(unsigned char *eitbuf, int len,
                           vector<MMSTVChannelData *> channels, vector<MMSEPGData *> &epg);
        bool readEPG(vector<MMSTVChannelData *> channels, vector<MMSEPGData *> &epg,
                     string file = "/dev/dvb/adapter0/demux0", unsigned int timeout = 30);
        void writeDump(void *ptr, size_t *ritems, size_t size, size_t nitems);
        void writeDumpStr(string str);
};

#endif /*MMSEPGIMPORTPLUGIN_H_*/
