/***************************************************************************
 *   Copyright (C) 2005-2006 by                                            *
 *                                                                         *
 *      Stefan Schwarzer <sxs@morphine.tv>                                 *
 *      Guido Madaus     <bere@morphine.tv>                                *
 *      Jens Schneider   <pupeider@morphine.tv>                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef MMSMIXERPLUGIN_H_
#define MMSMIXERPLUGIN_H_

#include "mmsbase.h"
#include "mmsmedia.h"
#include "mmsgui.h"
#include "mmsinput.h"
#include "mmssound.h"

class MMSMixerPlugin : public IMMSBackendPlugin {
	private:
        MMSLogger           logger;
        MMSPluginData       plugindata;

        MMSDialogManager    dm;

        MMSPopupWindow      *window;
        MMSLabel            *message;
        MMSProgressBar      *pBar;

		void onSubscriptionKey(DFBInputDeviceKeySymbol key);
		void subscribeKey(DFBInputDeviceKeySymbol key);

		MMSAudioCtrl	*mixer;

		MMSSound	*mmssound;

	public:
        /* constructor/destructor */
        MMSMixerPlugin();        
        virtual ~MMSMixerPlugin();

        /* interface methods */
        bool initialize(MMSPluginData data);
        bool onEvent(IMMSEvent *event);
        bool shutdown();
};

#endif /*MMSMIXERPLUGIN_H_*/
