/***************************************************************************
 *   Copyright (C) 2005-2006 by                                            *
 *                                                                         *
 *      Stefan Schwarzer <sxs@morphine.tv>                                 *
 *      Guido Madaus     <bere@morphine.tv>                                *
 *      Jens Schneider   <pupeider@morphine.tv>                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef MMSMUSICPLUGIN_H_
#define MMSMUSICPLUGIN_H_

#include "interfaces/immscentralplugin.h"
#include "mmstools.h"
#include "mmsbase.h"
#include "mmsgui.h"
#include "mmssound.h"
#include "mmsmusicthread.h"

typedef struct {
    string name;
    double length;
} MUSICINFO;

class MMSMusicPlugin : public IMMSCentralPlugin {
    private:
        MMSLogger           logger;
        MMSPluginData       plugindata;

        string              srcdir;

        vector<MUSICINFO *> musiclist;
        int                 mlpos;

        MMSTheme            *theme;

        MMSDialogManager    dm;
        MMSRootWindow       *window;
        MMSMenu             *menu;
        MMSMenu             *menu2;

#ifdef USE_MMSSOUND
        MMSSound            *mmssound;
#else
        MMSVideo            *mmssound;
#endif

        MMSMusicThread      *mt;

        bool                fireStart;
        bool                fireStop;

    public:
        /* constructor/destructor */
        MMSMusicPlugin();
        virtual ~MMSMusicPlugin();

        /* interface methods */
        bool initialize(MMSPluginData data);
        bool onEvent(IMMSEvent *event);
        bool shutdown();
        bool show();

        void playNext();
        void onFirstStart(MMSMusicThread *thread);
        void onStop(MMSMusicThread *thread);
        void onHide(MMSWindow *window, bool goback);
        void onSelectItem(MMSWidget *widget);
};

#endif /*MMSMUSICPLUGIN_H_*/
