/***************************************************************************
 *   Copyright (C) 2005-2006 by                                            *
 *                                                                         *
 *      Stefan Schwarzer <sxs@morphine.tv>                                 *
 *      Guido Madaus     <bere@morphine.tv>                                *
 *      Jens Schneider   <pupeider@morphine.tv>                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef MMSMUSICTHREAD_H_
#define MMSMUSICTHREAD_H_

#include "mmstools.h"
#include "mmsmedia.h"
#include <sigc++/sigc++.h>

/* use MMSVideo instead MMSSound to play sound if USE_MMSSOUND is not defined here */
#define USE_MMSSOUND

class MMSMusicThread : public MMSThread {
    private:
#ifdef USE_MMSSOUND
        MMSSound    *mmssound;
#else
        MMSVideo    *mmssound;
#endif
        double      length;
        MMSLabel    *label;
        bool        firstStart;

        void threadMain();
    public:
#ifdef USE_MMSSOUND
        MMSMusicThread(MMSSound *mmssound);
#else
        MMSMusicThread(MMSVideo *mmsvideo);
#endif

        void setFirstStart(bool firstStart);
        void setVal(double length, MMSLabel *label);

        sigc::signal<void, MMSMusicThread*> onFirstStart;
        sigc::signal<void, MMSMusicThread*> onStop;
};

#endif /*MMSMUSICTHREAD_H_*/
