/***************************************************************************
 *   Copyright (C) 2005-2006 by                                            *
 *                                                                         *
 *      Stefan Schwarzer <sxs@morphine.tv>                                 *
 *      Guido Madaus     <bere@morphine.tv>                                *
 *      Jens Schneider   <pupeider@morphine.tv>                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef MMSTVPLUGIN_H_
#define MMSTVPLUGIN_H_

#include "interfaces/immscentralplugin.h"
#include "mmstools.h"
#include "mmsbase.h"
#include "mmsgui.h"
#include "mmstv.h"
#include "mmsdata.h"

class MMSTVPlugin : public IMMSCentralPlugin {
    private:
        MMSLogger           logger;
        MMSPluginData       plugindata;
        MMSTVChannelService *tcs;
        MMSEPGService       *eps;

        MMSRootWindow       *window;

        MMSDialogManager    cmenu_dm;
        MMSMainWindow       *cmenu_window;
        MMSMenu             *cmenu;
        MMSTextBox          *cepgtext;

        MMSDialogManager    emenu_dm;
        MMSMainWindow       *emenu_window;
        MMSLabel            *ecaption;
        MMSMenu             *emenu;
        MMSTextBox          *eepgtext;

        vector<MMSTVChannelData *> channels;

        unsigned int        currChannel;
        string              currChannelName;

        MMSTV               *mmstv;

    public:
        /* constructor/destructor */
        MMSTVPlugin();
        virtual ~MMSTVPlugin();

        /* interface methods */
        bool initialize(MMSPluginData data);
        bool onEvent(IMMSEvent *event);
        bool shutdown();
        bool show();

        void onHide(MMSWindow *window, bool goback);
        void onHandleInput(MMSWindow *window, DFBInputDeviceKeySymbol key);
        void onSelectCItem(MMSWidget *widget);
        void onSelectEItem(MMSWidget *widget);
        void onReturn(MMSWidget *widget);
        void switchChannel();
        string buildEPGString(MMSEPGData *epgdata);
};

#endif /*MMSTVPLUGIN_H_*/
