#!/bin/bash
function usage {
	echo "usage:"
	echo ""
	echo "registerme.sh <mms installation>"
	exit 1
}

if [ -z $1 ] 
then
	PREFIX=`pkg-config --variable=prefix mmstools`
	if [ -z $PREFIX ]
	then
		usage;
	fi
else
	PREFIX=$1
fi


if [ ${0:0} = "." ]
then
	work=$PWD$0
else
	work=$0
fi

scripts=${work/registerme.sh/}
workspace=$scripts/../../

echo "Workspace Path: $workspace"
echo ""

# create destination

mkdir -vp $PREFIX/plugins/mmstvplugin

cp -v $workspace/mmstvplugin/Debug/libmmstvplugin.so $PREFIX/plugins/mmstvplugin
cp -v $workspace/mmstvplugin/share/* $PREFIX/plugins/mmstvplugin

echo
echo "updating db"
sqlite3 $PREFIX/db/mmsconfigdb <$workspace/mmstvplugin/scripts/register.sql

